{$i-}

program TREN;
{$APPTYPE CONSOLE}
uses
  sysutils;

{
 Time-Rename

 Benennt Dateien so um, dass das Entstehungsdatum der
 Datei zum neuen Namen wird, damit in Digitalfotosammlungen
 nicht mit jedem neuen "Film" wieder ein neues Bild0001.JPG
 in die Sammlung kommt.

 (c) Martin Vogel http://www.martinvogel.de

 Version 3.30 16. April 2006
 - bergabe mehrerer Dateinamen mglich, um Mehrfachselektionen
   aus Windows-Dialogen abarbeiten zu knnen.
 Version 3.20 26. Mrz 2005
 - wenn Dateiname mit Pfad bergeben wurde, wird vor dem
   Umbenennen in diesen Pfad gewechselt.
 Version 3.10 7. Mai 2002
 erstes Update 10. Februar 2001
 erste Version 4. Oktober 2000
}
const Version='3.30';

type tformat=(lang,mittel,kurz);
var format:tformat;
VAR S:String;
var b:byte;
CONST umbenannt:word=0;
const mitAltemNamen:boolean=false;

procedure hilfe;
begin

writeln('TREN ',version,' (c) 2000-2006 Martin Vogel - Freeware'#13#10#10,
        'Benennt Dateien unter Win32 so um,'#13#10,
        'dass der Dateiname aus der Dateizeit abgeleitet wird.'#13#10#10,
        'Format: TREN /schalter "Maske"'#13#10#10,
        'Beispiel: TREN /l "*.JPG"'#13#10#10,
        'Schalter: /l /m /k fuer langes, mittleres und kurzes Ausgabeformat'#13#10,
        '          /n fuegt den alten Namen an');
writeln(#10'Weitere Infos auf http://www.martinvogel.de');
write(#10'[Enter]');
readln;
halt(1);
end;

function endung(ns:string):string;
var i:word;
var e:string;
begin
  e:='';
  i:=length(ns);
  repeat
    e:=ns[i]+e;
    dec(i);
  until (i=0) or (e[1]='.');
  if i=0 then endung:='' else endung:=e;
end;


function unquote(s:string):string;
begin
  if (s='"') or (s='""') then s:='';
  if (s[1]='"') and (s[length(s)]='"')
  then unquote:=copy(s,2,length(s)-2)
  else unquote:=s;
end;

procedure zerlege(s:string;var nam,ext:string);
var n,l:integer;
begin
  l:=length(s);
  n:=l;
  repeat
    dec(n)
  until (n=2) or (s[n]='.');
  nam:=copy(s,1,n-1);
  ext:=copy(s,n,l-n+1);
end;

procedure trenmain(maske:string);
VAR F:integer;
var finddata:tsearchrec;
var zeit:tdatetime;
var n:integer;
var s,sn:string;
var neuname,neuext:string;
var letzterAlterName:String;
const AlteNamenAlleDurch:boolean=false;

begin
  getdir(0,s);writeln(s);
  if maske='' then hilfe;
  {Wenn der alte Name angehngt werden soll, muss das
   Programm rechtzeitig gestoppt werden, sonst bearbeitet
   es einige Dateien doppelt}
  LetzterAlterName:='';
  if MitAltemNamen then
  begin
    f := FindFirst (maske, faAnyFile, FindData);
    while f = 0 do
    begin
      letzterAlterName:=finddata.name;
      f:=FindNext(FindData)
    end;
    FindClose (FindData);
  end;
  f:=FindFirst(maske,faAnyFile, FindData);
  while (f = 0) and not AlteNamenAlleDurch do
  begin
    AlteNamenAlleDurch:=finddata.name=LetzterAlterName;
    zeit:=filedatetodatetime(finddata.time);
    case format of
    lang:   s:=FormatDateTime('yyyy"-"mm"-"dd"_"hh"h"nn"_"sszzz',zeit);
    mittel: s:=FormatDateTime('yy"-"mm"-"dd"_"hh"h"nn"_"ss',zeit);
    kurz:   s:=FormatDateTime('yymmddhhnnss',zeit);
    end {case};

    if mitAltemNamen
    then s:=s+'_'+finddata.name
    else s:=s+endung(finddata.name);
    write(finddata.name,' -> ',s);
    if RenameFile(finddata.name,s)
    then inc(umbenannt)
    else
    begin
      n:=1;
      zerlege(s,neuname,neuext);
      repeat
         write('|');
         inc(n);
         str(n,sn);
      until RenameFile(finddata.name,neuname+'('+sn+')'+neuext) or (n=1000);
      if n=1000 then write(' * kann nicht umbenannt werden *');
      writeln (maske,' - ',neuname+'('+sn+')'+neuext);
    end;

    writeln;
    f:=FindNext (FindData)
  end;
  FindClose (finddata);
end; {procedure trenmain}

function extractfilepath2(ein:string):string;
var s:string;
begin
  s:=extractfilepath(ein);
  if length(s)>4 then
    s:=copy(s,1,length(s)-1);
  extractfilepath2:=s;
end;

begin {program TREN}
if paramcount=0 then hilfe
else
begin
  format:=mittel;

  for b:=1 to paramcount do
  begin
    s:=paramstr(b);
    if s[1]='/'
    then
      case s[2] of
      'k','K','s','S': format:=kurz;
      'm','M': format:=mittel;
      'l','L': format:=lang;
      'n','N': mitAltemNamen:=true;
      else hilfe;
      end
  end;

  for b:=1 to paramcount do
  begin
    s:=paramstr(b);
    if s[1]<>'/'
    then
      begin
        chdir(ExtractFilePath2(unquote(s))); ioresult;
        trenmain(ExtractFileName(unquote(s)));
      end;
  end;

  writeln;
  writeln('TREN: ',umbenannt,' Dateien umbenannt.');
  writeln;
  writeln('Infos zu TREN: http://www.martinvogel.de');
end;
end.
